/*
 *  Prefs.h - Handhabung des Einstellungsfensters
 *
 *  Copyright (C) 1994-1996 by Christian Bauer
 */

#ifndef PREFS_H
#define PREFS_H

#include <exec/types.h>


// Preferences-Struktur
typedef struct {
  WORD	dummy;
  UWORD	normal_cycles;
  UWORD	bad_line_cycles;
  UWORD	CIA_cycles;
  WORD	joystick_1_on;
  WORD  joystick_2_on;
  WORD	joystick_swap;
  ULONG	display_id;
  UWORD	screen_type;
  char	dir_8[256];
  char	dir_9[256];
  char	dir_10[256];
  char	dir_11[256];
  UWORD	drv_8_type;
  UWORD	drv_9_type;
  UWORD	drv_10_type;
  UWORD	drv_11_type;
  UWORD	SID_type;
  WORD	other_IEC;
  WORD	keyboard_yz;
  WORD	collisions;
  UWORD	overscan;
  WORD	map_slash;
  WORD	fast_reset;
  UWORD	skip_latch;
  WORD	limit_speed;
  WORD	direct_video;
  WORD	sprites_on;
} Preferences;

// Laufwerkstypen
enum {
  DRVTYPE_DIR,	// 1541-Emulation in Amiga-Verzeichnis
  DRVTYPE_D64,	// 1541-Emulation in .d64-Datei
  DRVTYPE_IEC	// Echte 1541 am IEC-Kabel
};

// Bildschirmtypen
enum {
  SCRTYPE_8BIT,	// 8-Bit-Screen, WritePixelArray8
  SCRTYPE_4BIT,	// 4-Bit-Screen, c2p4
  SCRTYPE_1BIT	// 1-Bit-Screen, Amiga Mono
};

// SID-Typen
enum {
  SIDTYPE_OFF,	// Audio-Ausgabe aus
  SIDTYPE_CARD,	// SID-Karte
  SIDTYPE_A64,	// 6581sid.library
  SIDTYPE_PSID	// playsid.library
};


// Exportierte Funktionen
extern int DoThePrefs(Preferences *p);
extern void OpenPrefs(Preferences *p);
extern void LocalizePrefs(void);

#endif
